diff --git a/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c b/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
index 16dfb2e7c2..f6948b4bab 100644
--- a/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
+++ b/jerry-core/ecma/builtin-objects/ecma-builtin-number-prototype.c
@@ -253,7 +253,6 @@ ecma_builtin_number_prototype_object_to_string (ecma_number_t this_arg_number, /
   if (arguments_list_len == 0
       || ecma_number_is_nan (this_arg_number)
       || ecma_number_is_infinity (this_arg_number)
-      || ecma_number_is_zero (this_arg_number)
       || (arguments_list_len > 0 && ecma_is_value_undefined (arguments_list_p[0])))
   {
     ecma_string_t *ret_str_p = ecma_new_ecma_string_from_number (this_arg_number);
diff --git a/tests/jerry/regression-test-issue-3229.js b/tests/jerry/regression-test-issue-3229.js
new file mode 100644
index 0000000000..f72ceef58f
--- /dev/null
+++ b/tests/jerry/regression-test-issue-3229.js
@@ -0,0 +1,27 @@
+/* Copyright JS Foundation and other contributors, http://js.foundation
+ *
+ * Licensed under the Apache License, Version 2.0 (the "License");
+ * you may not use this file except in compliance with the License.
+ * You may obtain a copy of the License at
+ *
+ *     http://www.apache.org/licenses/LICENSE-2.0
+ *
+ * Unless required by applicable law or agreed to in writing, software
+ * distributed under the License is distributed on an "AS IS" BASIS
+ * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ * See the License for the specific language governing permissions and
+ * limitations under the License.
+ */
+
+var NISLFuzzingFunc = function(e) {
+  Number(0).toString(e);
+};
+
+var NISLParameter4 = "hello jerry";
+
+try {
+  NISLFuzzingFunc(NISLParameter4);
+  assert(false);
+} catch(e) {
+  assert(e instanceof RangeError);
+}
